/* ----- xdbase  -----*/
/* ----- 25-06-200 ---*/

#include "stdlib.h"
#include "stdio.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>


#include <string.h>
#include <dirent.h>
#include <sys/stat.h>

#include "setax.h"
#include "fix.c" 



#define ALTURA 2
#define NUMDB 2
#define DBCOLORTI 7
#define DBCOLORNO 0
#define DBCOLORTE 1
#define DBCOLORBA 4
#define DBCOLORED 4
#define DBPAPERED 5



int opendb(char *nombre,int numdb);
int closedb(int numdb);
void verdb(int num,int x,int y,int numdb);
void verregdb(int num,int reg,int x,int y,int numdb);
void vervar(int x,int y,int numdb);
void vervarreg(int reg,int x,int y,int numdb);
void editdb(int num,int x,int y,int numdb);
void editregdb(int num,int reg,int x,int y,int numdb);
void appedb(int numdb);
void deldb(int num,int numdb);
void nodeldb(int num,int numdb);
void packdb(int numdb);
char verdeldb(int num,int numdb);
void estadodb(void);
void marco(void);
void inputndb(int ta,int de,int x,int y);
void inputcdb(int ta,int x,int y);
void inputddb(int x,int y);
int creardb(void);


FILE *pfdb[NUMDB];
char nombredb[12*NUMDB];
unsigned char cabecera[35];
unsigned char  *cabememo[NUMDB];
unsigned int totalcampos[NUMDB],primercampo[NUMDB];
unsigned int tamaregs[NUMDB],numreg[NUMDB];
long tamano[NUMDB];
char tamareg[1000][NUMDB];
unsigned int z,zz,t,tt,i,vx,vy;
int yy;
unsigned char *ppv,*ppv1;

unsigned long xcolor;
 


main(int argc,char *argv[])
{
      
   strncpy(VARI,"X-DBASE",12); 
   mode(10);
   setfont("8x16");
   vx=2+FONTX; vy=2+FONTY;
   paleta();
   XMoveWindow(Midisplay,Miventana,16,16);

   if(argc==2)if(-1!=opendb(argv[1],0)) goto inicio;
   t=0;
       while(0==t)
	{
        XEvent event;
	XNextEvent (Midisplay, &event);
	Mievent=&event;
	switch (event.type)
         {
	  case Expose:
	      	marco();
 		PAPER=9; INK=1;
 		printc(210,150," BASE DE DATOS");
 		printc(210,200,"   (c) SETA   ");	
 		printc(210,250,"Dominio Publico");
 		INK=5;
 		printc(20,400,"Pulsa cualquier tecla para continuar o 'c' para crear base de datos");

	    break;
	  case KeyPress:
	    do_KeyPress ();
	    break;
	  case KeyRelease:
	    do_KeyRelease ();
	    break;
	  default:          
	    break;
	 }
	t=inkey();
	}
	if(t=='c' || t=='C') creardb();
   while(27!=Cficheros(2,2,3,27,"Archivos",".dbf"))
   	{ 

	 if(-1==opendb(VARI,0)){error(2);goto fin;}

	yy=0;
inicio:
	marco();
	estadodb(); 

     t=0;
     while(27!=t)
	{
        XEvent event;
	XNextEvent (Midisplay, &event);
	Mievent=&event;
	switch (event.type)
         {
	  case Expose:
	    goto inicio;
	    break;
	  case KeyPress:
	    do_KeyPress ();
	    break;
	  case KeyRelease:
	    do_KeyRelease ();
	    break;
	  case MotionNotify:
	    mouse(3);
	    break; 
	  case ButtonPress:
	    mouse(4);
	    break;
	  case ButtonRelease:
	    mouse(5);
	    break;
	  case DestroyNotify:
		printf("SALIR");
		closedb(0);
	    	goto salir;
	    break;
	  default:          
	    printf ("Unknown event type %d\n", event.type);
	    break;
	 }
	 
	 tt=inkey2();
	 t=inkey();
	 if(tt!=0)
   	 {
	  if(t>64 && t<91)t+=32;
	  if(tt==104 && numreg[0]-1>yy){yy++;}
	  if(tt==98 && yy!=0){yy--;}
	  if(tt==105){yy+=10;if(numreg[0]<=yy)yy=numreg[0]-1;}
	  if(tt==99){yy-=10;if(yy<0)yy=0;}
	  if(tt==97) yy=0;
	  if(tt==103) yy=numreg[0]-1;
	  if(t=='m')deldb(yy,0);
	  if(t=='n')nodeldb(yy,0);
	  if(t=='a'){ appedb(0);yy=numreg[0]-1; estadodb();}
	  if(t=='d'){ yy=0; packdb(0); estadodb();}
	  if(t=='e'){
			PAPER=1; if(FONTY==1)z=2; else z=1; 
			editdb(yy,12,5*z,0); clear(0); marco();
		    }
	  estadodb();         
	 }
    }
    closedb(0); 
fin:
   }
salir:
    mode(0); 
    exit (0);
}

/* ----- crear dbase ------- */
int creardb(void)
{
#define NUMCAMPOS 20

int y=5,z,num;
FILE *pf;
char nombre[12];
char campo[11][NUMCAMPOS];
char tipo[NUMCAMPOS];
unsigned int tamano[NUMCAMPOS];
unsigned int decimales[NUMCAMPOS];
unsigned int zz,z1;

	marco();
	PAPER=0;
	INK=1; printc(190,50,"CREAR BASE DE DATOS");
	inputc(0,10,"Nombre de la base de datos terminada en .dbf ->");
	printc(0,10,"                                                                ");
	for(z=0;z<12 && VARI[z]!=0;z++)nombre[z]=VARI[z];
	nombre[z]=0;
	INK=2; PAPER=0;
	printc(10,y*16,"Nombre"); printc(160,y*16,nombre);
	y+=2;
	num=0;
	while(num<NUMCAMPOS)
	{
novalido:
	INK=1;PAPER=0;
	inputc(0,10,"Nombre de campo (max. 9 caracteres) ->");
	printc(0,10,"                                                            ");
	for(z=0;z<11 && VARI[z]!=0;z++)campo[z][num]=VARI[z];
	if(z==0) break;
	INK=7; PAPER=9;
	for(;z<11;z++)campo[z][num]=0; VARI[z]=0; printc(160,y*16,VARI);
	INK=1; printc(10,y*16,"Campo"); printn(55,y*16,num);
volver:
	INK=1;PAPER=0;
	inputc(0,10,"Tipo de campo (c-cadena n-numero l-logico d-fecha) ");
	printc(0,10,"                                                                ");
	if(VARI[0]=='c' || VARI[0]=='C')
		{
		 decimales[num]=0;
		 INK=1;PAPER=0;
		 tamano[num]=inputn(0,10,"Tamao de la cadena max. 80 caracteres ");
		 printc(0,10,"                                                       ");
		 if(tamano[num]>80) goto volver;
		 INK=7; PAPER=9;printc(240,y*16,"Cadena"); printn(320,y*16,tamano[num]);
		 tipo[num]='C';
		 goto salto;
		}

	if(VARI[0]=='n' || VARI[0]=='N')
		{
		INK=1;PAPER=0;
		 tamano[num]=inputn(0,10,"Tamao del numero max. 80 caracteres ");
		 printc(0,10,"                                                       ");
		 if(tamano[num]>80) goto volver;
		 decimales[num]=inputn(0,10,"Numero de decimales max. 30 caracteres ");
		 printc(0,10,"                                                       ");
		 if(decimales[num]>30) goto volver;
		 INK=7; PAPER=9;printc(240,y*16,"Numero"); printn(320,y*16,tamano[num]);  				  printn(350,y*16,decimales[num]);
		 tipo[num]='N';
		 goto salto;
		}
	if(VARI[0]=='l' || VARI[0]=='L')
		{
         decimales[num]=0;
		 tamano[num]=1;
		 tipo[num]='L';
		 INK=7; PAPER=9;printc(240,y*16,"Logico"); printn(320,y*16,tamano[num]);
		 goto salto;
		}
	if(VARI[0]=='d' || VARI[0]=='D')
		{
         decimales[num]=0;
		 tamano[num]=8;
		 tipo[num]='D';
		 INK=7; PAPER=9;printc(240,y*16,"Fecha"); printn(320,y*16,tamano[num]);
		 goto salto;
		}
	goto novalido;
salto:
	y++; num++;
	}
	if((pf=fopen(nombre,"w+b"))==NULL){printc(0,0,"ERROR abriendo archivo"); return(-1);}
	putc(3,pf);
	/* fecha */
	putc(0,pf);
	putc(0,pf);
	putc(0,pf);
	/* numero de fichas por defecto 1 */
	putc(1,pf);
	putc(0,pf);
	putc(0,pf);
	putc(0,pf);
	/* direccin de primer campo */
	zz=(num+1)*32+1;
	putc((zz&0x00ff),pf);
	putc(((zz>>8)&0x00ff),pf);
	/* tamao de ficha */
	zz=0;
	for(z=0;z<num;z++){zz+=tamano[z]+decimales[z];	}
	z1=zz;
	putc((zz&0x00ff),pf);
	putc(((zz>>8)&0x00ff),pf);
	/* 20 bytes con cero */
	for(z=0;z<20;z++)putc(0,pf);
	/* cabecera de ficha, tamao 32 */
	for(zz=0;zz<num;zz++)
	{
	  /* nombre 10 caracteres y un cero */
	  for(z=0;z<11;z++)putc(campo[z][zz],pf);
	  /* tipo c/n/d/l */
	  putc(tipo[zz],pf);
	  /* ----xxxx---- */
	  putc(0,pf);
	  putc(0,pf);
	  putc(0,pf);
	  putc(0,pf);
	  /* tamao de la ficha */
	  putc(tamano[zz],pf);
	  /* numero de decimales */
	  putc(decimales[zz],pf);
	  /* 14 bytes reservados */
	  for(z=0;z<14;z++)putc(0,pf);
	}
	/* finaliza con un 13 */
	putc(13,pf);
	/* crea la primer ficha en blanco */
	for(z=0;z<z1;z++)putc(32,pf);
	/* termina con el caracter 26 */
	putc(26,pf);
	fclose(pf);
  return(1);
}
void marco(void)
{
	clear(1);
	INK=9; bar(2,66,637,458);
	INK=8; box(0,64,639,460);
	INK=8; box(2,66,637,458);
}
/* ---- Edita un fichero en una columna --- */
void editdb(int num,int x,int y,int numdb)
{
 unsigned int z;
 for(z=0;z<totalcampos[numdb];z++)
  {
  
   INK=DBCOLORED; PAPER=DBPAPERED; editregdb(num,z,x,y+z,numdb);
   INK=DBCOLORNO; PAPER=1; verregdb(num,z,x,y+z,numdb);
  }
}
/* ---- Entrada de un registro de un fichero ---- */
void editregdb(int num,int reg,int x,int y,int numdb)
{
char t;
unsigned int z,zz;
long indi;
 if(num<0||num>numreg[numdb]||reg>totalcampos[numdb]||reg<0)goto fin;
 ppv=cabememo[numdb];
 ppv=cabememo[numdb]+reg*32+43;
 switch(*ppv)
	{
	 case 'N':
	  printc(50<<vx,64,"Numero           ");
          printn(64<<vx,64,*(ppv+5));
          printn(68<<vx,64,*(ppv+6));
	  verregdb(num,reg,x,y,numdb);
	  inputndb(*(ppv+5),*(ppv+6),x<<vx,y<<vy);
	 break;
	 case 'D':
	  printc(50<<vx,64,"Fecha            ");
	  verregdb(num,reg,x,y,numdb);
	  inputddb(x<<vx,y<<vy);
	 break;
	 case 'L':
	  printc(50<<vx,64,"Logico T=Verdad F=Falso");
	  verregdb(num,reg,x,y,numdb);
	  z=VARI[0]; t=0;
	  while(t!=84 && t!=70 && t!=27 && t!=13)
	  {
	   t=xinkey(); if(t>96 && t<123)t-=32;
	   if(t==84 || t==70){ VARI[0]=t; impri(x,y,VARI[0]);} else {VARI[0]=z;}
	  }
	 break;
	 case 'C':
	  printc(50<<vx,64,"Alfanumerico           ");
	  printn(64<<vx,64,*(ppv+5));
	  verregdb(num,reg,x,y,numdb);
	  inputcdb(*(ppv+5),x<<vx,y<<vy);
	  break;
	 default:
	 goto fin;
	}
	zz=0;
	for(z=0;z<reg;z++)zz+=tamareg[z][numdb];
	indi=primercampo[numdb]+num*(tamaregs[numdb])+zz;
	fseek(pfdb[numdb],indi,0);
	fwrite(VARI,*(ppv+5),1,pfdb[numdb]);
fin:
;
}
/* ---- Entrada de fecha --------- */
void inputddb(int x,int y)
{
int z,zz,n,ta=10;
	z=x; n=0; zz=0;
        
	while(zz!=13 && n<ta)
		{
		 
		 zz=xinkey();
		 if(zz==13 || zz==27) goto fin;
		 if((zz>47 && zz<58) || zz==8 )
			{
			 if(zz==8){ if(n!=0){z-=FONTXX;n--;impri(z,y,32);} }
				else
				{
				  impri(z,y,zz);
				  if(n<38){z+=FONTXX; VARI[n]=zz; n++; }
				  if(n==2 || n==5){VARI[n]='/';n++;z+=FONTXX;}
				}
			}
		}
fin:
             strncpy(VARI+20,VARI,10);
			 strncpy(VARI,VARI+26,4);
			 strncpy(VARI+4,VARI+23,2);
			 strncpy(VARI+6,VARI+20,2);
			 VARI[8]=0;
}
/* ---- Entrada de una cadena ---- */
void inputcdb(int ta,int x,int y)
{
int z,zz,n;

        while(0==(zz=xinkey()));
        if(zz>31 && zz<124)
           {
            for(z=0;z<79 && VARI[z]!=0;z++)VARI[z]=32;
            printc(x,y,VARI);
           }
        z=x; n=0;
        goto salto;
  while(zz!=27 && zz!=13 && n<ta)
    {
     	zz=xinkey();
salto:
	if(zz==13 || zz==27) goto fin;
	if(zz!=0)
		{
		 if(zz==8)
			{
			 if(n!=0){z-=FONTXX;n--;impri(z,y,32);}
			}
			else
			{
			 impri(z,y,zz);
			 if(n<38){z+=FONTXX; VARI[n]=zz; n++; }
			}
		}
    }
fin:
;
}
/* ---- Entrada de un numero ---- */
void inputndb(int ta,int de,int x,int y)
{
int z,zz,n;

   	n=0; zz=0; de=ta-de;
        while(0==(zz=xinkey()));
        if(zz>47 && zz<58)
           {
            for(z=0;z<38 && VARI[z]!=0;z++)VARI[z]=32;
            printc(x,y,VARI);
           }
        z=x;
        goto salto;
  while(zz!=27 && zz!=13 && n<ta)
    {
     	zz=xinkey();
salto:
	if(zz==13 || zz==27) goto fin;
	if((zz>47 && zz<58) || zz==8)
			{
			 if(zz==8){ if(n!=0){z-=FONTXX;n--;impri(z,y,32);} }
				else
				{
				  impri(z,y,zz);
				  if(n<38){z+=FONTXX; VARI[n]=zz; n++; }
				  if(n==de){VARI[n]='.';n++;z+=FONTXX;}
				}
			}
		}
fin:
   for(z=ta;z>=0 && (VARI[z]==0 || VARI[z]==32);z--);
   z++;
   for(zz=ta;z>=0 && z<ta;z--,zz--){ VARI[zz]=VARI[z]; VARI[z]=32;}
}
void estadodb(void)
{
long indi;
int z;
   	
        if(FONTY==1)z=2; else z=1;
	INK=DBCOLORNO; PAPER=1; verdb(yy,12,5*z,0);
	INK=DBCOLORTE; PAPER=4; vervar(1,5*z,0);
  
        FONTY=2;
	INK=DBCOLORED; PAPER=1;
	printc(8,48,"   "); printc(40,48,"   ");
	printn(8,48,yy+1); printn(40,48,numreg[0]);
	if(verdeldb(yy,0)==42)printc(80,48,"BORRADA"); else printc(80,48,"       ");
        
	INK=DBCOLORTI;
	strncpy(VARI,nombredb,12); VARI[13]=0; printc(160,48,VARI);
	sprintf(VARI,"Nume. campos=%d  dir.1.campo=%d  tamao base=%d ",totalcampos[0],primercampo[0],tamano[0]);
	printc(8,0,VARI);
	sprintf(VARI,"tamao regs=%d  Num.fichas=%d    ",tamaregs[0],numreg[0]);
	printc(8,16,VARI);
	indi=primercampo[0]+yy*(tamaregs[0])-1;
	sprintf(VARI," Direccion -> %d",indi);
	printc(280,16,VARI);
	INK=DBCOLORBA;
        
	printc(1,462," M-Marca   N-NoMarca   D-Borra Fi.Mar.   E-Edita   A-Aade");
        FONTY=ALTURA;
}
/* ---- Inserta una ficha mas ---- */
void appedb(int numdb)
{
long indi;
unsigned int z;
	indi=primercampo[numdb]+numreg[numdb]*(tamaregs[numdb])-1;
	fseek(pfdb[numdb],indi,0);
	z=1+tamaregs[numdb];
	for(;z>0;z--)putc(32,pfdb[numdb]);
	putc(26,pfdb[numdb]);
	numreg[numdb]++;
	tamano[numdb]+=tamaregs[numdb];
	ppv=cabememo[numdb]+4; *ppv=0x00FF&numreg[numdb];
	ppv++;	*ppv=0x00FF&(numreg[numdb]>>8);
	fseek(pfdb[numdb],4,0);
	fwrite(cabememo[numdb]+4,2,1,pfdb[numdb]);
}
/* ---- Marca la ficha con * de borrado ---- */
void deldb(int num,int numdb)
{
long indi;
	if(num<0||num>numreg[numdb])goto fin;
	indi=primercampo[numdb]+num*(tamaregs[numdb])-1;
	fseek(pfdb[numdb],indi,0);
	fputc(42,pfdb[numdb]);
fin:
;
}
/* ---- Elimina marca de borrado ---- */
void nodeldb(int num,int numdb)
{
long indi;
	if(num<0||num>numreg[numdb])goto fin;
	indi=primercampo[numdb]+num*(tamaregs[numdb])-1;
	fseek(pfdb[numdb],indi,0);
	fputc(32,pfdb[numdb]);
fin:
;
}
/* ---- Borra todas las fichas marcadas con * ---- */
void packdb(int numdb)
{
long indi;
unsigned int z,zz,conta;
	if(NULL==(ppv=malloc(tamano[numdb]))){error(8); goto fin;}
	fseek(pfdb[numdb],0,0);	fread(ppv,tamano[numdb],1,pfdb[numdb]);
	conta=0; zz=numreg[numdb];
	for(z=0;z<zz;z++)
		{
		 indi=primercampo[numdb]+z*(tamaregs[numdb])-1;
		 ppv1=ppv+indi;
		 if(*ppv1==42)
			{
			 strncpy(ppv1,ppv1+tamaregs[numdb],tamaregs[numdb]*(numreg[numdb]+1));
			 conta++; zz--; z--;
			}
		}
	if(numreg[numdb]==conta)
		{
		 conta--;
		 ppv1=ppv+primercampo[numdb]-1;
		 for(z=0;z<tamaregs[numdb];z++,ppv1++){*ppv1=32;}
		 *ppv1=26;
		}
	tamano[numdb]-=conta*tamaregs[numdb];
	numreg[numdb]-=conta;
	ppv1=ppv+4; *ppv1=0x00FF&numreg[numdb];
	ppv1++;	*ppv1=0x00FF&(numreg[numdb]>>8);
	closedb(numdb);
	strncpy(VARI,nombredb+12*numdb,12); VARI[13]=0;
	if((pfdb[numdb]=fopen(VARI,"w+b"))==NULL){error(2); goto fin1;}
	fseek(pfdb[numdb],0,0); fwrite(ppv,tamano[numdb],1,pfdb[numdb]);
	fclose(pfdb[numdb]);
    if(-1==opendb(VARI,numdb))error(2);
fin1:
	free(ppv);
fin:
;
}
/* ---- Ve el estado de las fichas ---- */
char verdeldb(int num,int numdb)
{
 long indi;
	if(num<0||num>numreg[numdb])return(-1);
	indi=primercampo[numdb]+num*(tamaregs[numdb])-1;
	fseek(pfdb[numdb],indi,0);
	return(fgetc(pfdb[numdb]));
}
/* ---- ver cabeceras en columnas ---- */
void vervar(int x,int y,int numdb)
{
int z;
	ppv=cabememo[numdb]+32;
	for(z=0;z<totalcampos[numdb];z++)
	{
	 strncpy(VARI,ppv,32); VARI[32]=0;
	 printc(x<<vx,(y+z)<<vy,VARI);
	 ppv+=32;
	}
}
/* ---- ver cabecera de registro en x,y ---- */
void vervarreg(int reg,int x,int y,int numdb)
{
	ppv=cabememo[numdb]+32*(reg+1);
	strncpy(VARI,ppv,32); VARI[32]=0;
	printc(x<<vx,y<<vy,VARI);
}
/* ---- cierra base de datos ---- */
int closedb(int numdb)
{
	fclose(pfdb[numdb]);
        free(cabememo[numdb]);
}
/*---- Abre un base de datos -----*/
int opendb(char *nombre,int numdb)
{
	if((pfdb[numdb]=fopen(nombre,"r+b"))==NULL) return(-1);
	strncpy(nombredb+numdb*12,nombre,12);
        fseek(pfdb[numdb],0,2);
        tamano[numdb]=ftell(pfdb[numdb]);
	fseek(pfdb[numdb],0,0);	fread(cabecera,1,32,pfdb[numdb]);
	numreg[numdb]=cabecera[4]+cabecera[5]*255;
	totalcampos[numdb]=0; i=32; tamaregs[numdb]=0;
volver:
	fseek(pfdb[numdb],i,0);
	fread(cabecera,1,34,pfdb[numdb]);
	z=cabecera[16];
	tamaregs[numdb]= tamaregs[numdb]+z;
	tamareg[totalcampos[numdb]][numdb]=z;
	i+=32;	totalcampos[numdb]++;
	if(cabecera[32]!=13 ) goto volver;
	tamaregs[numdb]++;
	primercampo[numdb]=i+2;
	if(cabecera[33]==0)primercampo[numdb]++;
	if(NULL==(cabememo[numdb]=malloc(primercampo[numdb]))) error(8);
	fseek(pfdb[numdb],0,0);
	fread(cabememo[numdb],primercampo[numdb],1,pfdb[numdb]);
}
/* -----ver base de datos en columna----- */
void verdb(int num,int x,int y,int numdb)
{
int z,zz;
long indi;
	if(num<0||num>numreg[numdb])goto fin;
	indi=primercampo[numdb]+num*(tamaregs[numdb]);
	fseek(pfdb[numdb],indi,0);
	for(z=0;z<totalcampos[numdb];z++)
		{
		 fread(VARI,1,tamareg[z][numdb],pfdb[numdb]);
		 VARI[tamareg[z][numdb]]=0;
		 ppv=cabememo[numdb]+z*32+43;
		 if(*ppv=='D')
			{
             strncpy(VARI+20,VARI,10);
			 strncpy(VARI,VARI+26,2);
			 VARI[2]='/';
			 strncpy(VARI+3,VARI+24,2);
			 VARI[5]='/';
			 strncpy(VARI+6,VARI+20,4);
			 VARI[10]=0;
			}
		 printc(x<<vx,(y+z)<<vy,VARI);
		}
fin:
;
}
/* ------ver registro de una ficha en x,y ---- */
void verregdb(int num,int reg,int x,int y,int numdb)
{
int z,zz;
long indi;
	if(num<0||num>numreg[numdb]||reg>totalcampos[numdb]||reg<0)goto fin;
	zz=0;
	for(z=0;z<reg;z++)zz+=tamareg[z][numdb];
	indi=primercampo[numdb]+num*(tamaregs[numdb])+zz;
	fseek(pfdb[numdb],indi,0);
	fread(VARI,1,tamareg[reg][numdb],pfdb[numdb]);
	VARI[tamareg[reg][numdb]]=0;
	ppv=cabememo[numdb]+z*32+43;
		 if(*ppv=='D')
			{
             strncpy(VARI+20,VARI,10);
			 strncpy(VARI,VARI+26,2);
			 VARI[2]='/';
			 strncpy(VARI+3,VARI+24,2);
			 VARI[5]='/';
			 strncpy(VARI+6,VARI+20,4);
			 VARI[10]=0;
			}
	printc(x<<vx,y<<vy,VARI);
fin:
;
}
